Private Sub tvNamespaces(ByVal Node As MSComctlLib.Node)
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tvNamespaces(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem
Dim nsp As pgNamespace

  If Node.Children = 0 Or Node.Children <> svr.Databases(Node.Parent.Text).Namespaces.Count(Not ctx.IncludeSys) Then
    While Not (Node.Child Is Nothing)
      tv.Nodes.Remove Node.Child.Index
    Wend
    For Each nsp In svr.Databases(Node.Parent.Text).Namespaces
      If Not (nsp.SystemObject And Not ctx.IncludeSys) Then Set nsp.Tag = tv.Nodes.Add(Node.Key, tvwChild, "NSP-" & GetID, nsp.Identifier, "namespace")
    Next nsp
    Node.Text = "Schemas (" & Node.Children & ")"
  End If
  lv.ColumnHeaders.Add , , "Schema"
  lv.ColumnHeaders.Add , , "Comment"
  For Each nsp In svr.Databases(Node.Parent.Text).Namespaces
    If Not (nsp.SystemObject And Not ctx.IncludeSys) Then
      Set lvItem = lv.ListItems.Add(, "NSP-" & GetID, nsp.Identifier, "namespace", "namespace")
      lvItem.SubItems(1) = Replace(nsp.Comment, vbCrLf, " ")
    End If
  Next nsp
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvNamespaces"
End Sub


Public Sub tv_NodeClick(ByVal Node As MSComctlLib.Node)
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tv_NodeClick(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem
Dim szTemp As String
Dim vData As Variant

  StartMsg "Examining database..."
  
  lv.ColumnHeaders.Clear
  lv.ListItems.Clear
  lv.Tag = Node.FullPath
  sv.ColumnHeaders.Clear
  sv.ListItems.Clear
  If txtDefinition.Visible Then txtDefinition.Text = ""
  
  'Stats are only on 7.2+
  If ctx.dbVer < 7.2 Then
    sv.ColumnHeaders.Add , , "Statistics", sv.Width
    sv.ListItems.Add , , "Statistics are only available with PostgreSQL 7.2 or higher", "database", "database"
  End If
  
  Select Case Left(Node.Key, 4)

    Case "SVR-" 'Server
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr
      tvServer Node
      If ctx.dbVer >= 7.2 Then svServer Node

    Case "DAT+" 'Databases
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      tvDatabases Node
      If ctx.dbVer >= 7.2 Then svDatabases Node
        
    Case "DAT-" 'Database
      ctx.CurrentDB = Node.Text
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Databases(Node.Text)
      tvDatabase Node
      If ctx.dbVer >= 7.2 Then svDatabase Node
      
    Case "GRP+" 'Groups
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      tvGroups Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "GRP-" 'Group
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Groups(Node.Text)
      tvGroup Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "USR+" 'Users
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      tvUsers Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "USR-" 'User
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Users(Node.Text)
      tvUser Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "CST+" 'Casts
      ctx.CurrentDB = Node.Parent.Text
      ctx.CurrentNS = ""
      tvCasts Node
      If ctx.dbVer >= 7.2 Then ClearStats
    
    Case "CST-" 'Cast
      ctx.CurrentDB = Node.Parent.Parent.Text
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Text).Casts(Node.Text)
      tvCast Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "LNG+" 'Languages
      ctx.CurrentDB = Node.Parent.Text
      ctx.CurrentNS = ""
      tvLanguages Node
      If ctx.dbVer >= 7.2 Then ClearStats

    Case "LNG-" 'Language
      ctx.CurrentDB = Node.Parent.Parent.Text
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Text).Languages(Node.Text)
      tvLanguage Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "NSP+" 'Namespaces
      ctx.CurrentDB = Node.Parent.Text
      ctx.CurrentNS = ""
      tvNamespaces Node
      If ctx.dbVer >= 7.2 Then ClearStats

    Case "NSP-" 'Namespaces
      ctx.CurrentDB = Node.Parent.Parent.Text
      ctx.CurrentNS = Node.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Text).Namespaces(Node.Text)
      tvNamespace Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "AGG+" 'Aggregates
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvAggregates Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "AGG-" 'Aggregate
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Aggregates(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvAggregate Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "DOM+" 'Domains
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvDomains Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "DOM-" 'Domain
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Domains(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvDomain Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "CNV+" 'Conversion
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvConversions Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "CNV-" 'Conversion
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Conversions(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvConversion Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "FNC+" 'Functions
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvFunctions Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "FNC-" 'Function
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Functions(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvFunction Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "OPR+" 'Operators
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvOperators Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "OPR-" 'Operator
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Operators(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvOperator Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "SEQ+" 'Sequences
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvSequences Node
      If ctx.dbVer >= 7.2 Then svSequences Node

    Case "SEQ-" 'Sequence
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Sequences(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvSequence Node
      If ctx.dbVer >= 7.2 Then svSequence Node
      
    Case "TBL+" 'Tables
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvTables Node
      If ctx.dbVer >= 7.2 Then svTables Node
      
    Case "TBL-" 'Table
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Tables(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvTable Node
      If ctx.dbVer >= 7.2 Then svTable Node
      
    Case "CHK+" 'Checks
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvChecks Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "CHK-" 'Check
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).Checks(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvCheck Node
      If ctx.dbVer >= 7.2 Then ClearStats
    
    Case "COL+" 'Columns
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvColumns Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "COL-" 'Column
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).Columns(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvColumn Node
      If ctx.dbVer >= 7.2 Then svColumn Node
      
    Case "FKY+" 'Foreign Keys
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvForeignKeys Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "FKY-" 'Foreign Key
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).ForeignKeys(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvForeignKey Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "REL+" 'Relationships
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Parent.Text
      tvRelationships Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "IND+" 'Indexes
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvIndexes Node
      If ctx.dbVer >= 7.2 Then svIndexes Node
      
    Case "IND-" 'Index
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).Indexes(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvIndex Node
      If ctx.dbVer >= 7.2 Then svIndex Node

    Case "RUL+" 'Rules
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvRules Node
      If ctx.dbVer >= 7.2 Then ClearStats
  
    Case "RUL-" 'Rule
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).Rules(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvRule Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "TRG+" 'Triggers
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Parent.Parent.Text
      tvTriggers Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "TRG-" 'Trigger
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Parent.Parent.Text).Tables(Node.Parent.Parent.Text).Triggers(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Parent.Parent.Text
      tvTrigger Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "TYP+" 'Types
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvTypes Node
      If ctx.dbVer >= 7.2 Then ClearStats

    Case "TYP-" 'Type
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Types(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvType Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "VIE+" 'Views
      ctx.CurrentDB = Node.Parent.Parent.Parent.Text
      ctx.CurrentNS = Node.Parent.Text
      tvViews Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
    Case "VIE-" 'View
      ctx.CurrentDB = Node.Parent.Parent.Parent.Parent.Text
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Parent.Text).Views(Node.Text)
      ctx.CurrentNS = Node.Parent.Parent.Text
      tvView Node
      If ctx.dbVer >= 7.2 Then ClearStats
      
  End Select
    
  AutoSizeColumnLv lv
  AutoSizeColumnLv sv
  EndMsg
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvNodeClick"
End Sub

Private Sub tvConversions(ByVal Node As MSComctlLib.Node)
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tvConversions(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem
Dim conv As pgConversion

  If Node.Children = 0 Or Node.Children <> svr.Databases(Node.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Text).Conversions.Count(Not ctx.IncludeSys) Then
    While Not (Node.Child Is Nothing)
      tv.Nodes.Remove Node.Child.Index
    Wend
    For Each conv In svr.Databases(Node.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Text).Conversions
      If Not (conv.SystemObject And Not ctx.IncludeSys) Then Set conv.Tag = tv.Nodes.Add(Node.Key, tvwChild, "CNV-" & GetID, conv.Identifier, "conversion")
    Next
    Node.Text = "Conversions (" & Node.Children & ")"
  End If
  lv.ColumnHeaders.Add , , "Conversion"
  For Each conv In svr.Databases(Node.Parent.Parent.Parent.Text).Namespaces(Node.Parent.Text).Conversions
    If Not (conv.SystemObject And Not ctx.IncludeSys) Then
      Set lvItem = lv.ListItems.Add(, "CNV-" & GetID, conv.Identifier, "conversion", "conversion")
    End If
  Next
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvConversions"
End Sub

Private Sub tvConversion(ByVal Node As MSComctlLib.Node)
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tvConversion(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem
  
  lv.ColumnHeaders.Add , , "Property"
  lv.ColumnHeaders.Add , , "Value"
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Name", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Name
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "OID", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.OID
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Owner", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Owner
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Default", "property", "property")
  If ctx.CurrentObject.Default Then
    lvItem.SubItems(1) = "Yes"
  Else
    lvItem.SubItems(1) = "No"
  End If
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Source", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.ForEncoding
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Destination", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.ToEncoding
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Function", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Proc
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "System Conversion?", "property", "property")
  If ctx.CurrentObject.SystemObject Then
    lvItem.SubItems(1) = "Yes"
  Else
    lvItem.SubItems(1) = "No"
  End If

  'Set the Definition Pane
  If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvConversion"
End Sub

Private Sub mnuPopupProperties_Click()
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.mnuPopupProperties_Click()", etFullDebug

      Select Case ctx.CurrentObject.ObjectType
        Case "Aggregate"
          Dim objAggregateForm As New frmAggregate
          Load objAggregateForm
          objAggregateForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objAggregateForm.Show
          
        Case "Cast"
          Dim objCastForm As New frmCast
          Load objCastForm
          objCastForm.Initialise ctx.CurrentDB, ctx.CurrentObject
          objCastForm.Show
          
        Case "Column"
          Dim objColumnForm As New frmColumn
          Load objColumnForm
          objColumnForm.Initialise ctx.CurrentDB, ctx.CurrentNS, "MP", ctx.CurrentObject
          objColumnForm.Show
          
        Case "Database"
          Dim objDatabaseForm As New frmDatabase
          Load objDatabaseForm
          objDatabaseForm.Initialise ctx.CurrentObject
          objDatabaseForm.Show
          
        Case "Domain"
          Dim objDomainForm As New frmDomain
          Load objDomainForm
          objDomainForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objDomainForm.Show
          
        Case "Conversion"
          Dim objConversionForm As New frmConversion
          Load objConversionForm
          objConversionForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objConversionForm.Show
          
        Case "Foreign Key"
          Dim objForeignKeyForm As New frmForeignKey
          Load objForeignKeyForm
          objForeignKeyForm.Initialise ctx.CurrentDB, ctx.CurrentNS, "MP", ctx.CurrentObject
          objForeignKeyForm.Show
          
        Case "Function"
          Dim objFunctionForm As New frmFunction
          Load objFunctionForm
          objFunctionForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objFunctionForm.Show

        Case "Group"
          Dim objGroupForm As New frmGroup
          Load objGroupForm
          objGroupForm.Initialise ctx.CurrentObject
          objGroupForm.Show
    
        Case "Index"
          Dim objIndexForm As New frmIndex
          Load objIndexForm
          objIndexForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objIndexForm.Show
          
        Case "Language"
          Dim objLanguageForm As New frmLanguage
          Load objLanguageForm
          objLanguageForm.Initialise ctx.CurrentDB, ctx.CurrentObject
          objLanguageForm.Show
          
        Case "Schema"
          Dim objNamespaceForm As New frmNamespace
          Load objNamespaceForm
          objNamespaceForm.Initialise ctx.CurrentDB, ctx.CurrentObject
          objNamespaceForm.Show
          
        Case "Operator"
          Dim objOperatorForm As New frmOperator
          Load objOperatorForm
          objOperatorForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objOperatorForm.Show
          
        Case "Rule"
          Dim objRuleForm As New frmRule
          Load objRuleForm
          objRuleForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objRuleForm.Show
          
        Case "Server"
          Dim objServerForm As New frmServer
          Load objServerForm
          objServerForm.Initialise ctx.CurrentObject
          objServerForm.Show
          
        Case "Sequence"
          Dim objSequenceForm As New frmSequence
          Load objSequenceForm
          objSequenceForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objSequenceForm.Show

        Case "Table"
          Dim objTableForm As New frmTable
          Load objTableForm
          objTableForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objTableForm.Show
          
        Case "Trigger"
          Dim objTriggerForm As New frmTrigger
          Load objTriggerForm
          objTriggerForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objTriggerForm.Show
          
        Case "Type"
          Dim objTypeForm As New frmType
          Load objTypeForm
          objTypeForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objTypeForm.Show
          
        Case "User"
          Dim objUserForm As New frmUser
          Load objUserForm
          objUserForm.Initialise ctx.CurrentObject
          objUserForm.Show
          
        Case "View"
          Dim objViewForm As New frmView
          Load objViewForm
          objViewForm.Initialise ctx.CurrentDB, ctx.CurrentNS, ctx.CurrentObject
          objViewForm.Show
          
        Case Else
          MsgBox "Cannot display properties for the current object.", vbExclamation, "Error"
      End Select
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.mnuPopupProperties_Click"
End Sub


Private Sub lv_ItemClick(ByVal Item As MSComctlLib.ListItem)
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.lv_ItemClick(" & QUOTE & Item.Text & QUOTE & ")", etFullDebug

Dim szPath() As String

  'Get the elements of the node path. This will indicate the path through the pgSchema hierarchy
  szPath = Split(lv.Tag, "\")
  
  Select Case Left(Item.Key, 4)

    Case "SVR-" 'Server
      Set ctx.CurrentObject = svr
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ""
        
    Case "DAT-" 'Database
      Set ctx.CurrentObject = svr.Databases(Item.Text)
      ctx.CurrentDB = Item.Text
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "GRP-" 'Group
      Set ctx.CurrentObject = svr.Groups(Item.Text)
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "USR-" 'User
      Set ctx.CurrentObject = svr.Users(Item.Text)
      ctx.CurrentDB = ""
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "CST-" 'Cast
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Casts(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "LNG-" 'Language
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Languages(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "NSP-" 'Namespace
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = Item.Text
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "AGG-" 'Aggregate
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Aggregates(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "DOM-" 'Domain
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Domains(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "CNV-" 'Conversion
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Conversions(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "FNC-" 'Function
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Functions(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "OPR-" 'Operator
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Operators(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
 
    Case "SEQ-" 'Sequence
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Sequences(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "TBL-" 'Table
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "CHK-" 'Check
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).Checks(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = svr.Databases(ctx.CurrentDB).Namespaces(ctx.CurrentNS).Tables(ctx.CurrentObject.Table).SQL
      
    Case "COL-" 'Column
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).Columns(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = svr.Databases(ctx.CurrentDB).Namespaces(ctx.CurrentNS).Tables(ctx.CurrentObject.Table).SQL

    Case "FKY-" 'Foreign Key
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).ForeignKeys(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = svr.Databases(ctx.CurrentDB).Namespaces(ctx.CurrentNS).Tables(ctx.CurrentObject.Table).SQL
      
    Case "IND-" 'Index
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).Indexes(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
  
    Case "RUL-" 'Rule
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).Rules(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "TRG-" 'Trigger
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Tables(szPath(6)).Triggers(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL

    Case "TYP-" 'Type
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Types(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
    Case "VIE-" 'View
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Namespaces(szPath(4)).Views(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ctx.CurrentObject.Namespace
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
      
  End Select
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.lv_ItemClick"
End Sub

Private Sub mnuPopupCreateConversion_Click()
If inIDE Then: On Error GoTo 0: Else: On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.mnuPopupCreateConversion_Click()", etFullDebug

Dim objConversionForm As New frmConversion

  Load objConversionForm
  objConversionForm.Initialise ctx.CurrentDB, ctx.CurrentNS
  objConversionForm.Show
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.mnuPopupCreateConversion_Click"
End Sub
